<?php

namespace Drupal\swapcard_content\Plugin\QueueWorker;

/**
 * Creates QueueWorker for a data request.
 *
 * @QueueWorker(
 *   id = "swapcard_content_queue_swapcard_request",
 *   title = @Translation("Swapcard API Request"),
 *   cron = {"time" = 120}
 * )
 */
class SwapcardQueueWorkerRequest extends SwapcardQueueWorkerBase {

  /**
   * {@inheritdoc}
   */
  public function processItem($data) {

    $entities = $this->checkEventEntities();
    if (!isset($data['batch'])) {
      return;
    }
    $entities = $this->checkEventEntities();

    // This is Events only.
    if (empty($entities)) {
      $plugin_manager = $this->queueManager->createInstance('swapcard_content_queue_swapcard_event');
      return $plugin_manager->processRequest('swapcard_content_queue_swapcard_event', 'swapcard_event', 'events', $data['batch']);
    }
    // Some entities such as Exhibitors or Sessions are selected.
    else {
      if (isset($entities['entity_key']) && isset($entities['swapcard_callback'])) {
        $plugin_manager = $this->queueManager->createInstance('swapcard_content_queue_' . $entities['entity_key']);
        return $plugin_manager->processRequest('swapcard_content_queue_swapcard_event', $entities['entity_key'], $entities['swapcard_callback'], $data['batch']);
      }
    }
  }

}
